from InterfaceGenerator_MM import *

def getParentOfTheNode(node):
    if len(node.in_connections_)==1:
        for link in node.in_connections_:
            return link.in_connections_[0]
    return None

def getChildrenOfTheNode(node):  ## Returns all children ## GROUPLARIN TEMIZLENMESI COCUK SORUNU
    childrenList=[]
    if len(node.out_connections_)!=0:
        for link in node.out_connections_:
            print node.name.getValue()
            childrenList.append(link.out_connections_[0])
    return childrenList
    
def getGroupChildrenOfTheNode(node):
    childrenList=list()
    if len(node.out_connections_)!=0:
        for link in node.out_connections_:
            if isinstance(link.out_connections_[0],Group):
                childrenList.append(link.out_connections_[0])
    return childrenList

def getStateVariableChildrenOfTheNode(node):
    childrenList=list()
    if len(node.out_connections_)!=0:
        for link in node.out_connections_:
            if isinstance(link.out_connections_[0],StateVariable):
                childrenList.append(link.out_connections_[0])
    return childrenList

def getListGroupChildrenOfTheNode(node):
    childrenList=list()
    if len(node.out_connections_)!=0:
        for link in node.out_connections_:
            if isinstance(link.out_connections_[0],ListGroup):
                childrenList.append(link.out_connections_[0])
    return childrenList

def getCommandChildrenOfTheNode(node):
    childrenList=list()
    if len(node.out_connections_)!=0:
        for link in node.out_connections_:
            if isinstance(link.out_connections_[0],Command):
                childrenList.append(link.out_connections_[0])
    return childrenList


def getLinkToParent(node):
    if len(node.in_connections_) is not 0:
        return node.in_connections_[0]
    return None

###Updates

def updateNodes(node):
    allGroups=node.parent.ASGroot.listNodes['Group']
    allCommands=node.parent.ASGroot.listNodes['Command']
    allStateVariables=node.parent.ASGroot.listNodes['StateVariable']
    #Future work: another getter for listGroup ( also another for loop)
    
    for theNode in allGroups:
        theNode.outgoing.setValue(len(theNode.out_connections_))
    	theNode.incoming.setValue(len(theNode.in_connections_))

    	if theNode.incoming.getValue()>0 or theNode.outgoing.getValue()>0:
            theNode.isConnected.setValue(1)
    for theNode in allCommands:
        theNode.outgoing.setValue(len(theNode.out_connections_))
    	theNode.incoming.setValue(len(theNode.in_connections_))

    	if theNode.incoming.getValue()>0 or theNode.outgoing.getValue()>0:
            theNode.isConnected.setValue(1)

    for theNode in allStateVariables:
        theNode.outgoing.setValue(len(theNode.out_connections_))
    	theNode.incoming.setValue(len(theNode.in_connections_))

    	if theNode.incoming.getValue()>0 or theNode.outgoing.getValue()>0:
            theNode.isConnected.setValue(1)


def updateHeights(node):
    atom3i=node.parent
    allGroups=node.parent.ASGroot.listNodes['Group']
    allCommands=node.parent.ASGroot.listNodes['Command']
    allStateVariables=node.parent.ASGroot.listNodes['StateVariable']
    #Future work: another getter for listGroup ( also another for loop)

    for theNode in allGroups:
        if(getParentOfTheNode(theNode)!=None):
            theNode.height.setValue(getParentOfTheNode(theNode).height.getValue()+1)
    for theNode in allCommands:
	if(getParentOfTheNode(theNode)!=None):
            theNode.height.setValue(getParentOfTheNode(theNode).height.getValue()+1)
        else:
            theNode.height.setValue(0)
    for theNode in allStateVariables:
	if(getParentOfTheNode(theNode)!=None):
            theNode.height.setValue(getParentOfTheNode(theNode).height.getValue()+1)
        else:
            theNode.height.setValue(0)

   


def updateDirs(node):
    atom3i=node.parent
    allGroups=node.parent.ASGroot.listNodes['Group']
    allCommands=node.parent.ASGroot.listNodes['Command']
    allStateVariables=node.parent.ASGroot.listNodes['StateVariable']
    #Future work: another getter for listGroup ( also another for loop)

    for theNode in allGroups:
        if(getParentOfTheNode(theNode)!=None):
            theNode.directory.setValue(getParentOfTheNode(theNode).directory.getValue()+'.'+theNode.name.getValue())
        else:
            theNode.directory.setValue(theNode.name.getValue())
    for theNode in allCommands:
	if(getParentOfTheNode(theNode)!=None):
            theNode.directory.setValue(getParentOfTheNode(theNode).directory.getValue()+'.'+theNode.name.getValue())
        else:
            theNode.directory.setValue(theNode.name.getValue())
    for theNode in allStateVariables:
	if(getParentOfTheNode(theNode)!=None):
            theNode.directory.setValue(getParentOfTheNode(theNode).directory.getValue()+'.'+theNode.name.getValue())
        else:
            theNode.directory.setValue(theNode.name.getValue())


def moveNodeUnderAnotherNode(parent,node,atom3i):
    ###Future work: Also for ListGroup objects
    nextParent=parent
    
    link=getLinkToParent(node)
    link.removeNode()
    newLink=None

    if isinstance(node,Group):
        newLink=createNewhasGroup(atom3i,0,0)
        atom3i.drawConnections((parent,newLink,[0.0, 0.0, 0.0, 0.0],"true", 2))
        atom3i.drawConnections((newLink,node,[0.0, 0.0, 0.0, 0.0],"true", 2))
    elif isinstance(node,StateVariable):
        if isinstance(parent,Group):
            newLink=createNewhasStateVariable(atom3i,0,0)
        else:
            newLink=createNewcontains(atom3i,0,0)
        atom3i.drawConnections((parent,newLink,[0.0, 0.0, 0.0, 0.0],"true", 2))
        atom3i.drawConnections((newLink,node,[0.0, 0.0, 0.0, 0.0],"true", 2))
    elif isinstance(node,Command):
        newLink=createNewhasCommand(atom3i,0,0)
        atom3i.drawConnections((parent,newLink,[0.0, 0.0, 0.0, 0.0],"true", 2))
        atom3i.drawConnections((newLink,node,[0.0, 0.0, 0.0, 0.0],"true", 2))

    deleteEmptyGroups(node)

def deleteEmptyGroups(node):
    atom3i=node.parent
    allGroups=node.parent.ASGroot.listNodes['Group']
    link=None
    for group in allGroups:
        if len(getChildrenOfTheNode(group))==0:
            ###remove the group node
            link=getLinkToParent(group)
            group.graphObject_.erase(atom3i)
            link.removeNode()
            group.removeNode()
