from InterfaceGenerator_MM import *

def atLeastOneRoot(atom3i):
    count=0
    groups=atom3i.ASGroot.listNodes['Group']
    if len(groups)>=1:
        for group in groups:
            if group.isRoot.getValue()[1]==1:
                count=count+1
    if count==0:
        print ("Constraint atLeastOneRoot has failed")
        return("Constraint atLeastOneRoot has failed",atom3i)

def atLeastOneBase(atom3i):   ## ADD IT
    count=0
    groups=atom3i.ASGroot.listNodes['Group']
    if len(groups)>=1:
        for group in groups:
            if group.isRoot.getValue()[1]==1:
                count=count+1
    if count==0:
        print ("Constraint atLeastOneBase has failed")
        return("Constraint atLeastOneBase has failed",atom3i)



def maximumTwoRoot(atom3i):
    count=0
    for node in atom3i.ASGroot.listNodes['Group']:
        if node.isRoot.getValue()[1]==1:
            count=count+1
    if count>2:
        print ("Constraint maximumTwoRoot has failed")
        return("Constraint maximumTwoRoot has failed",atom3i)

def atLeastOneGroup(atom3i):
    for node in atom3i.ASGroot.listNodes['Node']:
        if isinstance(node,Group):
            return None
    print ("Constraint atLeastOneGroup has failed")
    return("Constraint atLeastOneGroup has failed",atom3i)

def atMostOneBaseRoot(atom3i):
    count=0
    groups=atom3i.ASGroot.listNodes['Group']
    if len(groups)>=1:
        for group in groups:
            if group.isRoot.getValue()[1]==1 and group.isBase.getValue()[1]==1:
                count=count+1
        if count>1:
            print ("Constraint atMostOneBaseRoot has failed")
    	    return("Constraint atMostOneBaseRoot has failed",atom3i)
    return None

###ABOUT NODE CLASS---EACH NODE OBJECT###

def isNodeConnected(node):
    if node.isConnected.getValue()[1]==0:
        print ("Constraint isNodeConnected has failed")
        return("Constraint isNodeConnected has failed",node)
    return None


#def nodeHasMaxOneIncoming(node):

def nodeHasOneIncoming(node): ## Except Root
    if not isinstance(node,Group) or node.isRoot.getValue()[1]==0:
        if node.incoming.getValue()!=1:
           print ("Constraint nodeHasOneIncoming has failed")
           return("Constraint nodeHasOneIncoming has failed",node)
    return None

 ###---- Group Node ----###

def rootCanBeBase(node):
    if node.isRoot.getValue()[1]!=1:
        if node.isBase.getValue()[1]==1:
            print ("Constraint rootCanBeBase has failed")
            return("Constraint rootCanBeBase has failed",node)
    return None


def rootHasNoIncoming(node):

    if node.isRoot.getValue()[1]==1:
        if node.incoming.getValue()>0:
            print ("Constraint rootHasNoIncoming has failed")
            return("Constraint rootHasNoIncoming has failed",node)
    return None

def groupHasGroupParent(node): ##Except Root

    if isinstance(node,Group):
        if node.isRoot.getValue()[1]!=1:
            for link in node.in_connections_:
                if isinstance(link.in_connections_[0],Group):
                    return None
                else:
                    print ("Constraint groupHasGroupParent has failed")
                    return("Constraint groupHasGroupParent has failed",node)
    return None


def groupIsNotLeaf(node):  ##Except Root(in case of one node-root tree)
    if isinstance(node,Group): 
         if node.isRoot.getValue()[1]!=1:
             if len(node.out_connections_)==0:
                 print ("Constraint groupsAreNotLeaf has failed")
                 return("Constraint groupsAreNotLeaf has failed",node)
   
###---- ListGroup Node ----### This part is for the future work
'''
def listGroupIsNotLeaf(node):
    if isinstance(node,ListGroup):
       if node.isConnected.getValue()[1]==1 and len(node.out_connections_)==0:
           print ("Constraint listGroupIsNotLeaf has failed")
           return("Constraint listGroupIsNotLeaf has failed",node)
    return None

def listGroupHasGroupParent(node):
    if isinstance(node,ListGroup):
        for link in node.in_connections_:
            if isinstance(link.in_connections_[0],Group):
                return None
            else:
                print ("Constraint listGroupHasGroupParent has failed")
                return("Constraint listGroupHasGroupParent has failed",node)
    return None

def listGroupOnlyHaveStateVariableChildren(node):
    if isinstance(node,ListGroup):
        for link in node.out_connections_:
            child=link.out_connections_[0]
            if not isinstance(child,StateVariable):
                 print ("Constraint listGroupOnlyHaveStateVariableChildren has failed")
        	 return("Constraint listGroupOnlyHaveStateVariableChildren has failed",node)

        return None
'''

###---- Command Node ----###

def commandIsLeaf(node):
    if isinstance(node,Command):
        if len(node.out_connections_)==1:
           print ("Constraint commandIsLeaf has failed")
           return("Constraint commandIsLeaf has failed",node)
    return None

def commandHasGroupParent(node):
    if isinstance(node,Command):
        for link in node.in_connections_:
            if isinstance(link.in_connections_[0],Group):
                return None
            else:
                print ("Constraint commandHasGroupParent has failed")
                return("Constraint commandHasGroupParent has failed",node)
    return None

###---- StateVariable Node ----###

def stateVariableIsLeaf(node):
    if isinstance(node,StateVariable):
        if len(node.out_connections_)==1:
           print ("Constraint stateVariableIsLeaf has failed")
           return("Constraint stateVariableIsLeaf has failed",node)
    return None



